------------------------------------------------------------------------------
--  This file is a part of the LPP VHDL IP LIBRARY
--  Copyright (C) 2013, Laboratory of Plasmas Physic - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
-------------------------------------------------------------------------------
--                    Author : Alexis Jeandet
--                     Mail : alexis.jeandet@lpp.polytechnique.fr
----------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

PACKAGE sample_type_LPP_JCP IS

  TYPE Samples IS ARRAY(NATURAL RANGE <>) OF STD_LOGIC_VECTOR(15 DOWNTO 0);

  SUBTYPE Samples24 IS STD_LOGIC_VECTOR(23 DOWNTO 0);
  SUBTYPE Samples16 IS STD_LOGIC_VECTOR(15 DOWNTO 0);
  SUBTYPE Samples14 IS STD_LOGIC_VECTOR(13 DOWNTO 0);
  SUBTYPE Samples12 IS STD_LOGIC_VECTOR(11 DOWNTO 0);
  SUBTYPE Samples10 IS STD_LOGIC_VECTOR( 9 DOWNTO 0);
  SUBTYPE Samples8  IS STD_LOGIC_VECTOR( 7 DOWNTO 0);

  TYPE Samples24v IS ARRAY(NATURAL RANGE <>) OF Samples24;
  TYPE Samples16v IS ARRAY(NATURAL RANGE <>) OF Samples16;
  TYPE Samples14v IS ARRAY(NATURAL RANGE <>) OF Samples14;
  TYPE Samples12v IS ARRAY(NATURAL RANGE <>) OF Samples12;
  TYPE Samples10v IS ARRAY(NATURAL RANGE <>) OF Samples10;
  TYPE Samples8v  IS ARRAY(NATURAL RANGE <>) OF Samples8;

  -- DSP/IIR
  TYPE samplT IS ARRAY(NATURAL RANGE <>, NATURAL RANGE <>) OF STD_LOGIC;  
  
END;
